import setuptools_scm
setuptools_scm.version
how_to_version = '''
all release version must be tagged on master
the develop branch version must tagged as vx.x.x.dev
if we see vx.x.x.post1.dev1 that means we are missing some tags
PyPi does not support +g<hash>, so release to PyPi only work
with exact tag, if HEAD has distance then it won't work.
Customizing version scheme does not really work,
because pypa/build does not call setup.py

We need to create a tag if we want to release to PyPi,
no matter it is stable or unstable.
'''
print(how_to_version)

template = """\
# file generated by setuptools_scm
# don't change, don't track in version control
TYPE_CHECKING = False
if TYPE_CHECKING:
    from typing import Tuple, Union
    VERSION_TUPLE = Tuple[Union[int, str], ...]
else:
    VERSION_TUPLE = object

version: str
__version__: str
__version_tuple__: VERSION_TUPLE
version_tuple: VERSION_TUPLE

__version__ = version = {version!r}
__version_tuple__ = version_tuple = {version_tuple!r}
scm_version = {{
"branch": "{scm_version.branch}",
"node": "{scm_version.node}",
"dirty": {scm_version.dirty}
}}
"""

print(setuptools_scm.get_version(
        version_scheme="no-guess-dev",
        local_scheme="node-and-timestamp",
        write_to_template=template,
        write_to="fast_speedtest/_version.py"
))
